#ifdef HAVE_XORG_CONFIG_H
#include <xorg-config.h>
#else
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif
#endif

#include "xf86.h"
#include "os.h"
#include "mibank.h"
#include "globals.h"
#include "xf86.h"
#include "xf86Priv.h"
#include "xf86DDC.h"
#include "mipointer.h"
#include "windowstr.h"
#include <randrstr.h>
#include <X11/extensions/render.h>

#include "xf86Crtc.h"
#include "xf86RandR12.h"

/* hw/xfree86/modes/xf86RandR12.c */

Bool
xf86RandR12SetConfig (ScreenPtr		pScreen,
		    Rotation		rotation,
		    int			rate,
		    RRScreenSizePtr	pSize)
{
    return FALSE;
}


Rotation
xf86RandR12GetRotation(ScreenPtr pScreen)
{
    return RR_Rotate_0;
}

Bool
xf86RandR12CreateScreenResources (ScreenPtr pScreen)
{
    return TRUE;
}

Bool
xf86RandR12Init (ScreenPtr pScreen)
{
    return FALSE;
}

void
xf86RandR12SetRotations (ScreenPtr pScreen, Rotation rotations)
{
}

void
xf86RandR12GetOriginalVirtualSize(ScrnInfoPtr pScrn, int *x, int *y)
{
    ScreenPtr pScreen = screenInfo.screens[pScrn->scrnIndex];

    *x = pScrn->virtualX;
    *y = pScrn->virtualY;
}

void
xf86RandR12TellChanged (ScreenPtr pScreen)
{
}

Bool
xf86RandR12PreInit (ScrnInfoPtr pScrn)
{
    return TRUE;
}

/* ./randr/rrproperty.c */

void
RRDeleteOutputProperty (RROutputPtr output, Atom property)
{
}

int
RRConfigureOutputProperty (RROutputPtr output, Atom property,
			   Bool pending, Bool range, Bool immutable,
			   int num_values, INT32 *values)
{
    return BadAlloc;
}

int
RRChangeOutputProperty (RROutputPtr output, Atom property, Atom type,
			int format, int mode, unsigned long len,
			pointer value, Bool sendevent, Bool pending)
{
    return BadAlloc;
}

Bool
RRPostPendingProperties (RROutputPtr output)
{
    return FALSE;
}

/* ./randr/rrcrtc.c */

Bool
RRCrtcGammaSet (RRCrtcPtr   crtc,
		CARD16	    *red,
		CARD16	    *green,
		CARD16	    *blue)
{
    if (!crtc)
	return TRUE;
    memcpy (crtc->gammaRed, red, crtc->gammaSize * sizeof (CARD16));
    memcpy (crtc->gammaGreen, green, crtc->gammaSize * sizeof (CARD16));
    memcpy (crtc->gammaBlue, blue, crtc->gammaSize * sizeof (CARD16));
    return TRUE;
}

/* i830_exa.c */

#include "i830.h"

#define xFixedToFloat(val) \
	((float)xFixedToInt(val) + ((float)xFixedFrac(val) / 65536.0))

static Bool
_i830_transform_point (PictTransformPtr transform,
                       float            x,
                       float            y,
                       float            result[3])
{
    int             j;

    for (j = 0; j < 3; j++)
    {
        result[j] = (xFixedToFloat (transform->matrix[j][0]) * x +
                     xFixedToFloat (transform->matrix[j][1]) * y +
                     xFixedToFloat (transform->matrix[j][2]));
    }
    if (!result[2])
        return FALSE;
    return TRUE;
}

Bool
i830_get_transformed_coordinates(int x, int y, PictTransformPtr transform,
                                 float *x_out, float *y_out)
{
    if (transform == NULL) {
        *x_out = x;
        *y_out = y;
    } else {
        float   result[3];

        if (!_i830_transform_point (transform, (float) x, (float) y, result))
            return FALSE;
        *x_out = result[0] / result[2];
        *y_out = result[1] / result[2];
    }
    return TRUE;
}

Bool
i830_get_transformed_coordinates_3d(int x, int y, PictTransformPtr transform,
                                    float *x_out, float *y_out, float *w_out)
{
    if (transform == NULL) {
        *x_out = x;
        *y_out = y;
        *w_out = 1;
    } else {
        float    result[3];

        if (!_i830_transform_point (transform, (float) x, (float) y, result))
            return FALSE;
        *x_out = result[0];
        *y_out = result[1];
        *w_out = result[2];
    }
    return TRUE;
}

