#
# spec file for package xorg-x11-driver-video-intel (Version 2.4.2)
#
# Copyright (c) 2009 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild


Name:           xorg-x11-driver-video-intel
BuildRequires:  Mesa-devel libdrm23-devel xorg-x11-devel xorg-x11-sdk
Url:            http://xorg.freedesktop.org/
License:        X11/MIT
Group:          System/X11/Servers/XF86_4
AutoReqProv:    on
Version:        2.4.2
Release:        0.8.10
Summary:        Various X.Org video drivers
Requires:       xorg-x11-server
Source:         xf86-video-intel-%{version}.tar.bz2
Source1:        xorg-72-addons.tar.bz2
Source2:        Imakefile
Source3:        compat_randr11.c
Source4:        Cards.xorg-x11-driver-video-intel
Source5:        Identity.map.xorg-x11-driver-video-intel
Patch:          intel_fixes.diff
Patch1:         intel_randr_reenable11.diff
Patch2:         intel_xvideo_apichange.diff
Patch3:         intel_dri.diff
Patch4:         intel_backport_clone.diff
Patch5:         i830_driver_20080505.diff
Patch8:         disable-tiling.diff
Patch9:         no-vgaHWSave-on-G4x.diff
Patch10:        xf86-video-intel-g41.diff
Patch11:        disable_render_standby.diff
Patch12:        memdetect-consistency-gm45.diff
Patch13:        disable_texturedvideo.diff
ExclusiveArch:  %ix86 x86_64
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
This package includes the following X.Org video drivers:

- ATI (ati, r128, radeon)

- Intel (i810)

- Matrox (mga)

- NVIDIA (nv)

- SIS (sis)

- VIA (via)



Authors:
--------
        Egbert Eich
        Keith Packard
        Roland Mainz
        Alan Coopersmith
        Russ Blaine
        Alexander Gottwald
        Alan Hourihane
        Chisato Yamauchi
        Eric Anholt
        Nolan Leake
        Stefan Dirsch
        Rik Faith
        Daniel Berrange
        Matthieu Herrb
        John Heasley
        Ryan Underwood
        Alex Deucher
        Ty Sarna
        Torrey T Lyons Darwin
        Stuart Kreitman
        Kevin E. Martin
        Greg Parker
        John Harper
        Adam Jackson
        Peter Kunzman
        Aaron Plattner
        Chisato Yamauchi
        Michel Daenzer
        Kristian Hgsberg
        Sren Sandmann
        Owen Taylor
        Mike A. Harris
        Ivan Kokshaysky
        Bryan Stine
        Guy Martin
        Paul Anderson
        Yu Shao
        David Dawes
        Harold L. Hunt II
        Andreas Luik
        Travis Tilley
        Ryan Lortie
        Ryan Breen
        Deron Johnson
        Ronny Vindenes
        Jim Gettys

%prep
%setup -n xf86-video-intel-%{version} -a 1
%patch0
%patch1
%patch2
%patch3
%patch4
%patch5
%patch8
%patch9
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p0
cp %SOURCE2 %SOURCE3 src/
rm -rf src/modes
cp man/intel.man src/
touch src/xorg-server.h

%build
cd src
xmkmf -a
# TTM: add "-DXF86DRI_MM -DHAVE_I915_FLIP"
make CDEBUGFLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing -I/usr/X11R6/%{_lib}/Server/include -I/usr/X11R6/%{_lib}/Server/include/extensions -I/usr/X11R6/include/drm -DPACKAGE_VERSION_MAJOR=2 -DPACKAGE_VERSION_MINOR=2 -DPACKAGE_VERSION_PATCHLEVEL=1 -include stdarg.h" PREPROCESSMANPAGES="true"

%install
cd src
make install DESTDIR=$RPM_BUILD_ROOT
make install.man DESTDIR=$RPM_BUILD_ROOT
find $RPM_BUILD_ROOT -name \*.la | xargs rm -f
###
### generate SaX2/hwinfo data
###
mkdir -p $RPM_BUILD_ROOT/usr/share/sax/sysp/maps/update/ \
         $RPM_BUILD_ROOT/usr/share/sax/api/data/cdb/ \
         $RPM_BUILD_ROOT/var/lib/hardware/ids
cp $RPM_SOURCE_DIR/Identity.map.%name \
   $RPM_BUILD_ROOT/usr/share/sax/sysp/maps/update
cp $RPM_SOURCE_DIR/Cards.%name \
   $RPM_BUILD_ROOT/usr/share/sax/api/data/cdb
cat > $RPM_BUILD_ROOT/var/lib/hardware/ids/%name << EOF
 vendor.id              pci 0x8086
&device.id              pci 0x2A42
+device.name            GM45
+driver.xfree           4|intel
+driver.xfree           4|intel|3d
 vendor.id              pci 0x8086
&device.id              pci 0x2E02
+device.name            IGD
+driver.xfree           4|intel
+driver.xfree           4|intel|3d
 vendor.id              pci 0x8086
&device.id              pci 0x2E22
+device.name            G45/G43
+driver.xfree           4|intel
+driver.xfree           4|intel|3d
 vendor.id              pci 0x8086
&device.id              pci 0x2E12
+device.name            Q45/Q43
+driver.xfree           4|intel
+driver.xfree           4|intel|3d
EOF
mkdir -p $RPM_BUILD_ROOT/etc/modprobe.d/
echo "install i915 /sbin/modprobe intel-agp; /sbin/modprobe -i i915" \
  > $RPM_BUILD_ROOT/etc/modprobe.d/%{name}

%clean
#rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc COPYING README
%dir /usr/share/sax
%dir /usr/share/sax/api
%dir /usr/share/sax/api/data
%dir /usr/share/sax/api/data/cdb
%dir /usr/share/sax/sysp
%dir /usr/share/sax/sysp/maps
%dir /usr/share/sax/sysp/maps/update
%dir /var/lib/hardware
%dir /var/lib/hardware/ids
%dir /usr/X11R6/%{_lib}/modules
%dir /usr/X11R6/%{_lib}/modules/drivers
/etc/modprobe.d/%name
/usr/X11R6/%{_lib}/modules/drivers/*.*
/usr/X11R6/man/man4/*
/usr/share/sax/api/data/cdb/Cards.%{name}
/usr/share/sax/sysp/maps/update/Identity.map.%{name}
/var/lib/hardware/ids/%{name}

%post
if ls var/lib/hardware/ids/* &> /dev/null; then
  cat var/lib/hardware/ids/* > var/lib/hardware/hd.ids
else
  rm -f var/lib/hardware/hd.ids
fi
exit 0

%postun
if ls var/lib/hardware/ids/* &> /dev/null; then
  cat var/lib/hardware/ids/* > var/lib/hardware/hd.ids
else
  rm -f var/lib/hardware/hd.ids
fi
exit 0

%changelog
* Fri Aug 14 2009 sndirsch@suse.de
- added SaX2 meta information for G41 (bnc #531144)
* Wed Jun  3 2009 sndirsch@suse.de
- disable_texturedvideo.diff
  * disable TexturedVideo, which results in Xserver crashes
    together with XAA on GM45/G4X; use overlay video instead
    (bnc #505497)
* Mon May 18 2009 sndirsch@suse.de
- memdetect-consistency-gm45.diff
  * recover consistence between agp and 2d aperture size
    calculation (bnc #503713)
* Fri May  8 2009 sndirsch@suse.de
- disable_render_standby.diff (bnc #501911)
  * Disable render standby. Render standby is known to cause
    possible hang issue on some mobile chips, so always disable it.
  * Move disable_render_standby to EnterVT instead of startup.
    Otherwise, with a pre-2.6.28 older kernel the disable would be
    lost at resume time and cause hangs. (bf #20214)
* Tue May  5 2009 sndirsch@suse.de
- xf86-video-intel-g41.diff
  * Add support for G41 chipset (FATE #305831)
* Thu Apr 16 2009 sndirsch@suse.de
- This package is required for Cantiga/Eaglelake support
  (FATE #305831)
* Thu Apr 16 2009 sndirsch@suse.de
- no-vgaHWSave-on-G4x.diff
  * workarounds blank screen on G4x platform when running in 32bit
    mode (bnc #426475)
* Wed Aug 27 2008 sndirsch@suse.de
- xf86-video-intel 2.4.2
  * regression fixes from 2.4.1
* Fri Aug 15 2008 sndirsch@suse.de
- added missing i830_hdmi.c as source to Imakefile
* Fri Aug 15 2008 sndirsch@suse.de
- xf86-video-intel 2.4.1
  * mostly bug and regression fixings for 2.4.0
* Fri Aug 15 2008 sndirsch@suse.de
- added SaX2/hwinfo meta information for Eaglelake devices, i.e.
  IGD, G45/G43 and Q45/Q43
* Wed Aug 13 2008 sndirsch@suse.de
- updated to xf86-video-intel 2.4.0
* Tue Aug 12 2008 sndirsch@suse.de
- disable-tiling.diff
  * disables tiling by default (bnc #402773)
* Wed Jul 30 2008 sndirsch@suse.de
- block_issue_2D.diff
  * likley fixed bnc #409145
* Thu Jul 17 2008 sndirsch@suse.de
- updated to xf86-video-intel 2.3.2
* Fri Jul 11 2008 sndirsch@suse.de
- changed "IGD" to "GM45" in SaX2/hwinfo meta files
* Fri Jul 11 2008 sndirsch@suse.de
- 0001-xf86_video_intel-official-name-for-GM45-chipset.diff
  * Cantiga official name is GM45 (bnc #402773)
* Mon May  5 2008 sndirsch@suse.de
- i830_driver_20080505.diff (Quanxian Wang, Intel)
  * fix segfault, which has been introduced by update to 2.3.0
* Wed Apr 30 2008 mhopf@suse.de
- Updated to Intel 2.3.0 driver
- updated patches accordingly
* Fri Feb  1 2008 sndirsch@suse.de
- updated to git cc1031a with IGD support
* Fri Jan 11 2008 mhopf@suse.de
- Initial release of backported Intel 2.2.0 driver
